/*******************************************************************************
*	FUNCTION: 	Cclose_display.c
*	LIBRARY:  	display
*	AUTHOR:	  	Scott Streit
*	DATE:     	11-03-1999
*	VERSION:  	1
*
*	DESCRIPTION:	This native method is used to close the connection
*			to a display window, such as SAOImage and Ximtool.
*
*	PARAMETERS:	disp_fd   File descriptor returned from Copen_display.
*
*	RETURNS:	None
*******************************************************************************/
#include "ImageDisplay.h"
#include "which_system.h"

JNIEXPORT void JNICALL
Java_ImageDisplay_Cclose_1display(JNIEnv *env, jclass clazz, jint disp_fd)
{
	/* Get the handle to the display window. */
	CDLPtr cdl = (CDLPtr)disp_fd;

	/* Terminate the connection. */
	cdl_close(cdl);
}
