/*******************************************************************************
*	FUNCTION: 	Copen_display.c
*	LIBRARY:  	display
*	AUTHOR:	  	Scott Streit
*	DATE:     	11-03-1999
*	VERSION:  	1
*
*	DESCRIPTION:	This native method opens a connection to the
*			image server (SAOImage/Ximtool) for displaying
*			an image.
*
*	PARAMETERS:	None
*
*	RETURNS:	Returns a reference to the opened server connection.
*			Throws an Exception if a connection to the display
*			server could not be established.
*******************************************************************************/
#include "ImageDisplay.h"
#include "which_system.h"

JNIEXPORT jint JNICALL
Java_ImageDisplay_Copen_1display(JNIEnv *env, jclass clazz)
{
	CDLPtr cdl;
	jclass newExcCls;
	
	/* Open the package and a connection to the server. */
        if (!(cdl = cdl_open ((char *)getenv("IMTDEV"))) ) {
			newExcCls = (*env)->FindClass(env, "java/lang/Exception");
        
        		/* Unable to find the new exception class, give up. */
        		if (newExcCls == 0)
        			return;

       			(*env)->ThrowNew(env, newExcCls, "ERROR: Could not open connection to dislay server \n");
        }
                   
	return (int)cdl;
}
