/*******************************************************************************
*	FUNCTION: 	Cget_memory_word.c
*	LIBRARY:  	mem
*	AUTHOR:	  	Scott Streit
*	DATE:     	11-03-1999
*	VERSION:  	1
*
*	DESCRIPTION:	This native method is used to retrieve a single word
*			(32 bits) from an image buffer.
*
*	PARAMETERS:	fd	The image buffer to get the data from.
*			index	The offset into the image buffer.
*
*	RETURNS:	Returns the data word at offset "index". Throws an
*			Exception if the image buffer to be accessed is NULL.
*******************************************************************************/
#include <stdio.h>
#include "Cmemory.h"
#include "MemorySetup.h"

JNIEXPORT jint JNICALL Java_MemorySetup_Cget_1memory_1word(JNIEnv *env, jclass clazz, jint fd, jint index)
{
	jclass newExcCls;
	addrPtr = (void *)fd;
		
	/* Check for a NULL image buffer. */
	if (addrPtr == NULL) {
		newExcCls = (*env)->FindClass(env, "java/lang/Exception");
        
        	/* Unable to find the new exception class, give up. */
        	if (newExcCls == 0)
        		return;

       		(*env)->ThrowNew(env, newExcCls, "Error! Attempting To Access A NULL Image Buffer. \n");
        }

	return addrPtr[index];
}
