/*******************************************************************************
*	FUNCTION: 	Cswap_memory.c
*	LIBRARY:  	mem
*	AUTHOR:	  	Scott Streit
*	DATE:     	11-03-1999
*	VERSION:  	1
*
*	DESCRIPTION:	This native method is used to byte swap the words
*			within the data Dwords.
*
*	PARAMETERS:	fd  		A reference to the image buffer.
*			mem_length	The number of bytes in the image buffer.
*
*	RETURNS:	None. An Exception is thrown if the image buffer is NULL.
*******************************************************************************/
#include <stdio.h>
#include "Cmemory.h"
#include "MemorySetup.h"

JNIEXPORT void JNICALL Java_MemorySetup_Cswap_1memory(JNIEnv *env, jclass clazz, jint fd, jint mem_length)
{
	int x;
	unsigned int word1;
	unsigned int word2;
	unsigned int temp1;
	unsigned int temp2;
	unsigned int temp3;
	unsigned int temp4;
	unsigned int temp5;
	unsigned int temp6;
	unsigned int temp7;
	unsigned int temp8;
	unsigned int temp9;
	jclass newExcCls;
	
	addrPtr = (void *)fd;
	
	/* Check for a NULL image buffer. */
	if (addrPtr == NULL) {
		newExcCls = (*env)->FindClass(env, "java/lang/Exception");
        
        	/* Unable to find the new exception class, give up. */
        	if (newExcCls == 0)
        		return;

       		(*env)->ThrowNew(env, newExcCls, "Error! Attempting To Access A NULL Image Buffer. \n");
        }

#if 0
	/* Swap the image data as Dwords. */
	for (x=0; x<(mem_length/2); x+=2) {
		word1 = addrPtr[x];
		word2 = addrPtr[x+1];
		addrPtr[x] = word2;
		addrPtr[x+1] = word1;
	}
#endif
	
	/* Swap the image data bytes within the Dwords. */
	for (x=0; x<(mem_length/4); x++) {
		temp1 = addrPtr[x];
		temp2 = addrPtr[x];
		temp3 = addrPtr[x];
		temp4 = addrPtr[x];
		
		temp5 = ((temp1 & 0xff) << 8);
		temp6 = ((temp2 & 0xff00) >> 8);
		temp7 = ((temp3 & 0xff0000) << 8);
		temp8 = ((temp4 & 0xff000000) >> 8);
		
		temp9 = (temp8 | temp7 | temp6 | temp5);
		
		addrPtr[x] = temp9;
	}
}
