/**
********************************************************************************
*	This class is the event listener for the array control options on the
*	main application window.
*
*	CVM - Controller
*
*	@version 1.00
*	@author Scott Streit
********************************************************************************
*/
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

public class ArrayControlListener implements ActionListener
{
	VoodooMainWindow parent;
	ArrayControlCommand array_cmd = null;

	/**
	*****************************************************************************
	*	Default constructor.
	*
	*	@param parent The window this event listener listens to.
	*
	*	@version 1.00
	*	@author Scott Streit
	*****************************************************************************
	*/
	public ArrayControlListener(VoodooMainWindow parent)
	{
		this.parent = parent;
		array_cmd = new ArrayControlCommand(parent);
	}

	/**
	*****************************************************************************
	*	This method overides the same one in the ActionListener
	*	interface. All events for the parent window are handled
	*	here.
	*
	*	@param e The event description.
	*
	*	@see ActionListener
	*	@version 1.00
	*	@author Scott Streit
	*****************************************************************************
	*/	
	public void actionPerformed(ActionEvent e)
	{
		AbstractButton active_button = (AbstractButton) e.getSource();
		
		// Set the camera command to send.
		array_cmd.set_command(active_button.getText());

		// Send the camera command.
		array_cmd.thread_it();
	}
}