/**
********************************************************************************
*	The event handler class for the FITS setup window.
*
*
*	CVM - Controller
*
*	@see FitsDialog
*	@see ActionListener
*	@version 1.00
*	@author Scott Streit
********************************************************************************
*/
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import javax.swing.*;

public class FitsDialogListener implements ActionListener
{
	private FitsDialog parent = null;
	private String message;
	
	/**
	********************************************************************************
	*	Constructor.
	*
	*	@param parent The window for which this class listens.
	*
	*	@see FitsDialog
	*	@version 1.00
	*	@author Scott Streit
	********************************************************************************
	*/
	public FitsDialogListener(FitsDialog parent)
	{
		this.parent = parent;
	}

	/**
	********************************************************************************
	*	This method overides the same one in the ActionListener
	*	interface. All events for the parent window are handled
	*	here.
	*
	*	@param e The event description.
	*
	*	@see ActionListener
	*	@version 1.00
	*	@author Scott Streit
	********************************************************************************
	*/	
	public void actionPerformed(ActionEvent e)
	{
		AbstractButton active_button = (AbstractButton) e.getSource();
		
		// Close the Fits Setup window.
		if (active_button.getText().equals("Close")) {
			parent.setVisible(false);
			parent.number_of_fits_windows = 0;
		}
	}
}