import java.awt.event.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;

public class ImageBuffersDialogListener implements ActionListener
{
	private ImageBuffersDialog parent = null;
	private boolean do_custom_buffer_size;
	private int image_buffer_size = 0;
	
	public ImageBuffersDialogListener(ImageBuffersDialog parent)
	{
		this.parent = parent;
		do_custom_buffer_size = false;
	}

	public void actionPerformed(ActionEvent e)
	{
		AbstractButton active_button = (AbstractButton) e.getSource();

		// Set the buffer size to 512x512.						
		if (active_button.getText().equals("512x512")) {
			image_buffer_size = 512*512*2;
			parent.image_buffer_totalSize_txtfld.setText(Integer.toString(image_buffer_size));
			do_custom_buffer_size = false;
		}
		
		// Set the buffer size to 1024x1024.						
		else if (active_button.getText().equals("1024x1024")) {
			image_buffer_size = 1024*1024*2;
			parent.image_buffer_totalSize_txtfld.setText(Integer.toString(image_buffer_size));
			do_custom_buffer_size = false;
		}
		
		// Set the buffer size to 2200x2200.						
		else if (active_button.getText().equals("2200x2200")) {
			image_buffer_size = 2200*2200*2;
			parent.image_buffer_totalSize_txtfld.setText(Integer.toString(image_buffer_size));
			do_custom_buffer_size = false;
		}
		
		// Set the buffer size to a custom size.						
		else if (active_button.getText().equals("Custom")) {
			do_custom_buffer_size = true;
			parent.image_buffer_totalSize_txtfld.setText("");
		}
		
		// Close the options window.
		else if (active_button.getText().equals("Close")) {
			parent.setVisible(false);
			parent.number_of_options_windows = 0;
		}
		
		// Set the current image buffer size.
		else if (active_button.getText().equals("Apply")) {
			if (do_custom_buffer_size) {
				try {
					int rows = Integer.parseInt(parent.image_buffer_rowSize_txtfld.getText());
					int cols = Integer.parseInt(parent.image_buffer_colSize_txtfld.getText());
					image_buffer_size = rows*cols*2;
					parent.image_buffer_totalSize_txtfld.setText(Integer.toString(image_buffer_size));
				}
				catch (NumberFormatException nfe) {
							PrintMessage.message("ImageBuffersDialogListener", 1, "ERROR: Cannot parse buffer dimensions.\n", 0, true);
				}
			}

			// Protect against accidentally pushing the apply button.
			if (image_buffer_size == 0)
				image_buffer_size = 2200*2200*2;
			
			// Free the current buffer.
			MemorySetup.free_memory();
			
			// Create the new memory buffer.
			MemorySetup mem_setup = new MemorySetup();
   			mem_setup.create_memory(image_buffer_size);
			
			PrintMessage.message("ImageBuffersDialogListener", 0, "\nImage buffers allocated: " + Integer.toString(image_buffer_size) + " bytes.\n", 0, true);
		}
	}
}