/**
********************************************************************************
*	This class provides initialization for all non-window objects that need 
*	initialization. In particular, the device driver C library functions are
*	enabled here along with any global constants and variables that are
*	needed.
*
*	CVM - Model
*
*	@version 1.00
*	@author Scott Streit
********************************************************************************
*/

public class ImageDisplay
{
  	public static int disp_fd;

  	// C function prototypes.
	private static native int Copen_display();
	private static native void Cclose_display(int disp_fd);
  	public static native int Cdisplay(int mem_fd, int rows, int cols);
	
  	// Load the library that contains the C functions.
  	static
  	{
    		System.loadLibrary("displibc");
  	}

	/**
	********************************************************************************
	*	Class Constructor.
	*
	*	@version 1.00
	*	@author Scott Streit
	********************************************************************************
	*/
  	public ImageDisplay()
  	{
    		disp_fd = 0;
  	}

	/**
	********************************************************************************
	*	This method opens a connection to the display device. Typically Ximtool
	*	or SAOimage.
	*
	*	@version 1.00
	*	@author Scott Streit
	********************************************************************************
	*/
/*
	public static void open_display()
	{
		disp_fd = Copen_display();
	}
*/
	
	/**
	********************************************************************************
	*	This method closes a connection to the display device. Typically Ximtool
	*	or SAOimage.
	*
	*	@version 1.00
	*	@author Scott Streit
	********************************************************************************
	*/
/*
	public static void close_display()
	{
		Cclose_display(disp_fd);
	}
*/
	
/*
	public static void main(String args[])
	{
		MemorySetup mem_setup = new MemorySetup();
		mem_setup.create_memory(2*100*100);
   	        System.out.println("\n java mem_fd = " + MemorySetup.mem_fd);	
		//mem_setup.fill_memory();
   		ImageDisplay imd = new ImageDisplay();
   		imd.Cdisplay(MemorySetup.mem_fd, 100, 100);
   		mem_setup.free_memory();
	}
*/
}
