package HideableFrame;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public abstract class HideableFrame extends JFrame 
{  public HideableFrame(int frame_width, int frame_height, String frame_title)
   {
      // Set the window to listen for events from itself.
      addWindowListener(new WindowAdapter() { public void windowClosing(WindowEvent e) { e.getWindow().setVisible(false); } } );

      // Set the window size.
      setSize(frame_width, frame_height);

      // Set the window title. 
      setTitle(frame_title);

      // Center the window on the screen.
      Toolkit tk = Toolkit.getDefaultToolkit();
      Dimension d = tk.getScreenSize();
      setLocation(d.width/8+100, d.height/8);

      // Make the window non-resizable.
      setResizable(false);
   }
}




